<?php
/**
 * @package     Guest Support
 * @author      RcaTheme.com <support@rcatheme.com>
 * @license     https://www.gnu.org/licenses/gpl-3.0.html GPLv3
 * @link        https://www.rcatheme.com
 * @copyright   2024 RcaTheme.com, All rights resered.
 */
defined('ABSPATH') or die;
$isagent = GuestSupportApp::isAgent();
$agent_id_enc = GuestSupportApp::AgentIdEncrypt();
$ispro = GuestSupportApp::isPro();
$datetime_formate = get_option('date_format') . ' ' . get_option('time_format');
$ticket_url = GuestSupportApp::getTicketPageUrl() . '?id=' . $ticketSubject->ticket_id . '&auth=' . $ticketSubject->ticket_token;
$current_url =  $ticket_url . ( $isagent ? '&agent=' . $agent_id_enc : '' );
$file_url = $ticket_url . '&guest_support_handler=download_file&file_id=';
$config = GuestSupportApp::config();
$custom_fields = unserialize( $ticketSubject->custom_fields );
$ticket_reopen_url = $current_url . '&guest_support_handler=reopenticket';
$ticket_reopen_text = '<a href="' . $ticket_reopen_url . '">' . esc_html__( 'Re-open this ticket', 'guest-support' ) . '</a>.';
$ticket_reopen_shorttext = '<a href="' . $ticket_reopen_url . '">' . esc_html__( 'Re-open', 'guest-support' ) . '</a>';

$agent_picture = '';
$user_picture = '';

if ( $ispro )
{
    // Get agent picture
    $agentId = GuestSupportApp::getAgentIdByDepartmentId( $ticketSubject->department_id );
    $agent_settings = GuestSupportAddonApp::getUserSettings( $agentId );
    if ( $agent_settings !== false )
    {
        $agent_picture = GuestSupportApp::uploadDirBaseurl() . '/guest-support-pictures/' . $agent_settings->picture;
    }

    if ( (int) $ticketSubject->user_id > 0 )
    {
        $user_settings = GuestSupportAddonApp::getUserSettings( $ticketSubject->user_id );
        if ( $user_settings !== false )
        {
            $user_picture = GuestSupportApp::uploadDirBaseurl() . '/guest-support-pictures/' . $user_settings->picture;
        }
    }
}

// Check if the agent is real agent or an admin
$is_realagent = true;
if ( $isagent )
{
	$ticketAgentId = GuestSupportApp::getAgentIdByDepartmentId( $ticketSubject->department_id );
	if ( $isagent != $ticketAgentId )
	{
		$is_realagent = false;
	}
}

// Params
$params_top_text = isset( $params['top_text'] ) ? $params['top_text'] : '';
$params_display_ticket_id = isset( $params['display_ticket_id'] ) ? esc_html( $params['display_ticket_id'] ) : 'none';
$params_display_ticket_status = isset( $params['display_ticket_status'] ) ? (int) $params['display_ticket_status'] : 1;
$params_display_department = isset( $params['display_department'] ) ? (int) $params['display_department'] : 1;
$params_display_ticket_creation_date = isset( $params['display_ticket_creation_date'] ) ? (int) $params['display_ticket_creation_date'] : 1;
$params_ticket_creation_date_format = isset( $params['ticket_creation_date_format'] ) ? esc_html( $params['ticket_creation_date_format'] ) : 'M n, Y h:iA';
$params_display_last_updated_date = isset( $params['display_last_updated_date'] ) ? (int) $params['display_last_updated_date'] : 1;
$params_last_updated_date_format = isset( $params['last_updated_date_format'] ) ? esc_html( $params['last_updated_date_format'] ) : 'M n, Y h:iA';
$params_display_custom_fields = isset( $params['display_custom_fields'] ) ? (int) $params['display_custom_fields'] : 1;
$params_display_other_tickets = isset( $params['display_other_tickets'] ) ? esc_html( $params['display_other_tickets'] ) : 'both';
$params_bottom_text = isset( $params['bottom_text'] ) ? $params['bottom_text'] : '';

$viewing_attachments = GuestSupportApp::getConfig( 'view_attachments', 'browser' );
?>

<div class="guest-support guest-support-ticket">
    <svg aria-hidden="true" xmlns="http://www.w3.org/2000/svg" id="svg-icon-global">
        <symbol id="ticket_attachment" viewBox="0 0 448 512">
            <path d="M375 72.97C349.1 46.1 306.9 46.1 280.1 72.97L88.97 264.1C45.32 308.6 45.32 379.4 88.97 423C132.6 466.7 203.4 466.7 247 423L399 271C408.4 261.7 423.6 261.7 432.1 271C442.3 280.4 442.3 295.6 432.1 304.1L280.1 456.1C218.6 519.4 117.4 519.4 55.03 456.1C-7.364 394.6-7.364 293.4 55.03 231L247 39.03C291.7-5.689 364.2-5.689 408.1 39.03C453.7 83.75 453.7 156.3 408.1 200.1L225.2 384.7C193.6 416.3 141.6 413.4 113.7 378.6C89.88 348.8 92.26 305.8 119.2 278.8L271 127C280.4 117.7 295.6 117.7 304.1 127C314.3 136.4 314.3 151.6 304.1 160.1L153.2 312.7C143.5 322.4 142.6 337.9 151.2 348.6C161.2 361.1 179.9 362.2 191.2 350.8L375 167C401 141.1 401 98.94 375 72.97V72.97z" fill="#24292e"></path>
        </symbol>
        <symbol id="ticket_file_upload" viewBox="0 0 512 512">
            <path d="M448 304h-128V352h128c8.822 0 16 7.178 16 16V448c0 8.822-7.178 16-16 16H64c-8.822 0-16-7.178-16-16v-80C48 359.2 55.18 352 64 352h128V304H64c-35.35 0-64 28.65-64 64V448c0 35.35 28.65 64 64 64h384c35.35 0 64-28.65 64-64v-80C512 332.7 483.3 304 448 304zM136.1 176.1L232 81.94V352c0 13.25 10.75 24 24 24s24-10.75 24-24V81.94l95.03 95.03C379.7 181.7 385.8 184 392 184s12.28-2.344 16.97-7.031c9.375-9.375 9.375-24.56 0-33.94l-136-136c-9.375-9.375-24.56-9.375-33.94 0l-136 136c-9.375 9.375-9.375 24.56 0 33.94S127.6 186.3 136.1 176.1zM432 408c0-13.26-10.75-24-24-24S384 394.7 384 408c0 13.25 10.75 24 24 24S432 421.3 432 408z"></path>
        </symbol>
        <symbol id="ticket_file_remove" viewBox="0 0 512 512">
            <path d="M0 256C0 114.6 114.6 0 256 0C397.4 0 512 114.6 512 256C512 397.4 397.4 512 256 512C114.6 512 0 397.4 0 256zM168 232C154.7 232 144 242.7 144 256C144 269.3 154.7 280 168 280H344C357.3 280 368 269.3 368 256C368 242.7 357.3 232 344 232H168z" fill="#FFFFFF"></path>
        </symbol>
        <symbol id="ticket_file_plus" viewBox="0 0 448 512">
            <path d="M432 256c0 17.69-14.33 32.01-32 32.01H256v144c0 17.69-14.33 31.99-32 31.99s-32-14.3-32-31.99v-144H48c-17.67 0-32-14.32-32-32.01s14.33-31.99 32-31.99H192v-144c0-17.69 14.33-32.01 32-32.01s32 14.32 32 32.01v144h144C417.7 224 432 238.3 432 256z"/>
        </symbol>
		<symbol id="ticket_lock" viewBox="0 0 448 512">
			<path d="M144 144v48H304V144c0-44.2-35.8-80-80-80s-80 35.8-80 80zM80 192V144C80 64.5 144.5 0 224 0s144 64.5 144 144v48h16c35.3 0 64 28.7 64 64V448c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V256c0-35.3 28.7-64 64-64H80z"/>
        </symbol>
    </svg>
    <div class="guest-support-grid">
        <div class="guest-support-block guest-support-size-65 guest-support-ticket-messages">
            <div class="guest-support-ticket-content">
                <h1 class="guest-support-ticket-subject"><?php echo esc_html( stripslashes( $ticketSubject->subject ) ); ?></h1>
                <div class="guest-support-ticket-messages-wrapper">
                    <?php foreach( $ticket as $message ) : ?>
                        <div <?php echo ($message === end($ticket) ? 'id="guest-support-ticket-message-last" ' : ''); ?>class="guest-support-ticket-message <?php echo esc_attr( $message->user_type ); ?>">
                            <div class="guest-support-ticket-message-spacer">&nbsp;</div>
                            <div class="guest-support-ticket-message-header guest-support-grid guest-support-vcenter">
                                <div class="guest-support-ticket-avatar">
                                    <?php 
                                        echo '<span class="guest-support-grid guest-support-vcenter">';
                                        if ( $message->user_type == 'user' && $user_picture )
                                        {
                                            echo '<img src="' . esc_url( $user_picture ) . '" alt="' . esc_attr( $message->name ) . '">';
                                        }
                                        elseif ( $message->user_type == 'agent' && $agent_picture )
                                        {
                                            echo '<img src="' . esc_url( $agent_picture ) . '" alt="' . esc_attr( $message->name ) . '">';
                                        }
                                        else
                                        {
                                            $first_char = substr($message->name, 0, 1);
                                            echo $first_char[0] ? esc_html( strtoupper( $first_char[0] ) ) : '?';
                                        }
                                        echo '</span>';
                                    ?>
                                </div>
                                <div class="guest-support-ticket-message-name-time">
                                    <h4><?php echo esc_html( $message->name ); ?></h4>
                                    <p>
                                        <span><?php echo esc_html( GuestSupportApp::timeElapsed($message->created_date, $message->ticket_timezone) ); ?></span>
                                        <?php
                                            if ( $config->can_edit_replies == 'both' || ( $config->can_edit_replies == 'agent' && $isagent ) || ( $config->can_edit_replies == 'user' && !$isagent ) )
                                            {
                                                if ( ( $isagent && $config->edit_replies_globally == 'yes' ) || $config->edit_reply_type == 'all' )
                                                {
                                                    echo '&nbsp;|&nbsp;<span><a href="javascript:;" id="guest_support_open_modal" data-modal="guest_support_edit_reply_modal" data-ticketid="' . esc_attr( $message->ticket_id ) . '" data-ticketauth="' . esc_attr( $message->ticket_token ) . '" data-messageid="' . esc_attr( GuestSupportApp::encrypt( $message->id ) ) . '" data-agent="' . esc_attr( $agent_id_enc ) . '">' . esc_html__( "Edit", "guest-support" ) . '</a></span>';
                                                }
                                                elseif ( $config->edit_reply_type == 'last' && $message === end($ticket) && ( ( $message->status == 'pending' && $isagent ) || ( $message->status == 'open' && !$isagent ) ) ) {
                                                    echo '&nbsp;|&nbsp;<span><a href="javascript:;" id="guest_support_open_modal" data-modal="guest_support_edit_reply_modal" data-ticketid="' . esc_attr( $message->ticket_id ) . '" data-ticketauth="' . esc_attr( $message->ticket_token ) . '" data-messageid="' . esc_attr( GuestSupportApp::encrypt( $message->id ) ) . '" data-agent="' . esc_attr( $agent_id_enc ) . '">' . esc_html__( "Edit", "guest-support" ) . '</a></span>';
                                                }
                                            }
                                        ?>
                                        <?php
                                            if ( $isagent && $message->message_type == 'reply' && $config->can_delete_replies == 'yes' )
                                            {
                                                echo '&nbsp;|&nbsp;<span><a id="guest-support-delete" href="' . esc_url( $current_url ) . '&replyid=' . GuestSupportApp::encrypt( $message->id ) . '&guest_support_handler=deletereply">' . esc_html__( "Delete", "guest-support" ) . '</a></span>';
                                            }
                                        ?>
                                    </p>
                                </div>
                            </div>
                            <div class="guest-support-ticket-message-content">
                                <div class="guest-support-ticket-message-contentblock">
                                    <?php echo wp_kses_post( GuestSupportApp::cleanMessageBody( $message->message ) ); ?>
                                </div>
                                <?php if ( isset( $message->files ) && !empty( $message->files ) ) : ?>
                                    <div class="guest-support-ticket-message-attachments">
                                        <ul>
                                            <?php foreach ( $message->files as $file ) : ?>
                                                <li class="guest-support-grid guest-support-vcenter">
                                                    <svg class="guest-support-ticket-attachment-icon" width="16px" height="16px"><use href="#ticket_attachment"></use></svg>
                                                    <?php
                                                        $fileexist = 0;
                                                        $fileurl = GuestSupportApp::uploadDirectory() . $file->file_name_enc;
                                                        if ( file_exists( $fileurl ) )
                                                        {
															$extension = pathinfo( $file->file_name_raw, PATHINFO_EXTENSION );
															if ( $viewing_attachments === 'browser' && in_array( $extension, [ 'jpg', 'jpeg', 'png', 'gif', 'pdf' ] ) )
															{
																$direct_file_url = GuestSupportApp::uploadDirBaseurl() . '/guest-support/' . $file->file_name_enc;
																echo '<a href="' . esc_url( $direct_file_url ) . '" target="_blank">' . esc_html( $file->file_name_raw ) . ' (' . esc_html( GuestSupportApp::bytesToReadable( $file->file_size ) ) . ')</a>';
															}
															else
															{
																echo '<a href="' . esc_url( $file_url . GuestSupportApp::encrypt( $file->file_id ) ) . '">' . esc_html( $file->file_name_raw ) . ' (' . esc_html( GuestSupportApp::bytesToReadable( $file->file_size ) ) . ')</a>';
															}
                                                        }
														else
														{
															echo '<a href="#">' . esc_html( $file->file_name_raw ) . ' (' . esc_html__( 'File not found.', 'guest-support' ) . ')</a>';
														}
                                                    ?>
                                                    <?php
                                                        if ( $isagent )
                                                        {
                                                            echo '&nbsp;-&nbsp;<span><a id="guest-support-delete" class="guest-support-delete-file" href="' . esc_url( $current_url . '&fileid=' . GuestSupportApp::encrypt( $file->file_id ) . '&guest_support_handler=deletefile' ) . '">' . esc_html__( "Delete", "guest-support" ) . '</a></span>';
                                                        }
                                                        elseif ( $message->user_type == 'user' )
                                                        {
                                                            echo '&nbsp;-&nbsp;<span><a id="guest-support-delete" class="guest-support-delete-file" href="' . esc_url( $current_url . '&fileid=' . GuestSupportApp::encrypt( $file->file_id ) . '&guest_support_handler=deletefile' ) . '">' . esc_html__( "Delete", "guest-support" ) . '</a></span>';
                                                        }
                                                    ?>
                                                </li>
                                            <?php endforeach; ?>
                                        </ul>
                                    </div>
                                <?php endif; ?>
                                <?php
                                    $reply_custom_fields = unserialize( $message->custom_fields );
                                    if ( $ispro && !empty( $reply_custom_fields ) )
                                    {
										$custom_fields_data = '';
                                        foreach ($reply_custom_fields as $name => $value) {
                                            $custom_info = '';
                                            $inputname = 'field_' . $name;
                                            if ( isset( $formFields[$inputname]['showonticketview'] ) && $formFields[$inputname]['showonticketview'] != 'hide' )
                                            {
                                                if ( ( is_array( $value ) && !empty( $value ) ) || !empty( $value ) )
                                                {
                                                    if ( isset( $formFields[$inputname]['label'] ) )
                                                    {
                                                        $custom_info .= '<h4 class="guest-support-custom-field-label-' . esc_attr( $name ) . '">' . esc_html( $formFields[$inputname]['label'] ) . ':</h4>';
                                                    }

													if ( !is_user_logged_in() && isset( $formFields[$inputname]['login_required'] ) && (int) $formFields[$inputname]['login_required'] === 1 )
													{
														$custom_info .= '<div class="guest-support-custom-field-value-login-required guest-support-alert guest-support-alert-warning"><span><svg width="16px" height="16px"><use href="#ticket_lock"></use></svg></span><div>' . esc_html__( 'Login to view this message.', 'guest-support' ) . '</div></div>';
													}
													else
													{
														if ( is_array( $value ) )
														{
															$fieldvalue = implode( ', ', $value );
														}
														else
														{
															$fieldvalue = str_replace( '__', ' ', $value);
														}
														$custom_info .= '<div class="guest-support-custom-field-value-' . esc_attr( $name ) . '">' . stripslashes( esc_html( $fieldvalue ) ) . '</div>';
													}
                                                }
                                                if ( ( $formFields[$inputname]['showonticketview'] == 'users' || $formFields[$inputname]['showonticketview'] == 'both' ) && !$isagent )
                                                {
													$custom_fields_data .= $custom_info;
                                                }
                                                elseif ( ( $formFields[$inputname]['showonticketview'] == 'agents' || $formFields[$inputname]['showonticketview'] == 'both' ) && $isagent )
                                                {
													$custom_fields_data .= $custom_info;
                                                }
                                            }
                                        }
										if ( $custom_fields_data )
										{
											echo '<div class="guest-support-ticket-message-custom-fields">';
											echo GuestSupportApp::wp_kses_extended( $custom_fields_data );
											echo '</div>';
										}
                                    }
                                ?>
                            </div>
                        </div>
                    <?php endforeach; ?>
                </div>
                <?php echo wp_kses_post( GuestSupportApp::getNotice() ); ?>
                <div class="guest-support-ticket-reply-wrapper">
                    <?php if ( $ticketSubject->status != 'closed' ) : ?>
                        <h3><?php esc_html_e( "Reply to this ticket", "guest-support" ); ?></h3>
                        <?php if ( $is_realagent === false && current_user_can( 'administrator' ) ) : ?>
							<div class="guest-support-alert guest-support-alert-warning"><p><?php esc_html_e( "Warning! This ticket was not assigned to you but to another support agent. However, admins can still reply as the agent.", "guest-support" ); ?></p></div>
						<?php endif; ?>

						<?php if ( $is_realagent === true || current_user_can( 'administrator' ) ) : ?>
							<div class="guest-support-form-wrapper">
								<form id="guest_support_reply_ticket_form" action="" method="post" enctype="multipart/form-data">
									<div class="guest-support-grid">
										<div class="guest-support-block guest-support-size-100">
											<div class="guest-support-field">
												<label for=""><?php esc_html_e( "Your Message", "guest-support" ); ?></label>
												<?php
													$content = "";
													$custom_editor_id = 'guest-support-field-message';
													$custom_editor_name = 'message';
													$args = array(
															'media_buttons' => false,
															'textarea_name' => $custom_editor_name,
															'textarea_rows' => get_option('default_post_edit_rows', 10),
															'quicktags' => false,
															'tinymce'       => array(
																'toolbar1'      => 'bold,italic,underline,separator,alignleft,aligncenter,alignright,separator,link,unlink,bullist,numlist,undo,redo',
																'toolbar2'      => '',
																'toolbar3'      => '',
															),
														);
													wp_editor( $content, $custom_editor_id, $args );
												?>
											</div>
										</div>

										<?php
											if ( $ispro && !empty( $formFields ) )
											{
												foreach ($formFields as $field) {
													if ( $field['fieldtype'] == 'custom' && $field['fieldtoform'] != 'ticket' )
													{
														$placeholder = isset( $field['placeholder'] ) ? stripslashes( $field['placeholder'] ) : '';
														echo '<div id="guest-support-block-' . esc_attr( $field['inputtype'] ) . '" class="guest-support-block guest-support-size-100' . ' guest-support-field-' . esc_attr( $field['name'] ) . '">';
														echo '<div class="guest-support-field">';
														if ( $field['label'] && $field['inputtype'] != 'hidden' && $field['inputtype'] != 'content' )
														{
															echo '<label for="guest-support-field-' . esc_attr( $field['name'] ) . '">' . esc_html( $field['label'] ) . '</label>';
														}
														if ( $field['inputtype'] == 'text' )
														{
															echo '<input type="text" name="' . esc_attr( $field['name'] ) . '" id="guest-support-field-' . esc_attr( $field['name'] ) . '" class="' . esc_attr( $form->input_class ) . '" value="" placeholder="' . esc_attr( $placeholder ) . '"' . ( $field['name'] == 'name' && $name ? ' disabled' : '' ) . ( $field['required'] == 1 ? ' required' : '' ) . '>';
														}
														elseif ( $field['inputtype'] == 'email' )
														{
															echo '<input type="email" name="' . esc_attr( $field['name'] ) . '" id="guest-support-field-' . esc_attr( $field['name'] ) . '" class="' . esc_attr( $form->input_class ) . '" value="" placeholder="' . esc_attr( $placeholder ) . '"' . ( $field['name'] == 'email' && $email ? ' disabled' : '' ) . ( $field['required'] == 1 ? ' required' : '' ) . '>';
														}
														elseif ( $field['inputtype'] == 'textarea' )
														{
															echo '<textarea name="' . esc_attr( $field['name'] ) . '" id="guest-support-field-' . esc_attr( $field['name'] ) . '" class="' . esc_attr( $form->input_class ) . '" rows="5" cols="40" placeholder="' . esc_attr( $placeholder ) . '"' . ( $field['required'] == 1 ? ' required' : '' ) . '></textarea>';
														}
														elseif ( $field['inputtype'] == 'select' )
														{
															echo '<select name="' . esc_attr( $field['name'] ) . '" id="guest-support-field-' . esc_attr( $field['name'] ) . '" class="' . esc_attr( $form->input_class ) . '"' . ( $field['required'] == 1 ? ' required' : '' ) . '>';
															if ( isset( $field['options'] ) && !empty( $field['options'] ) )
															{
																$optionsArr = preg_split( "/\r\n|\n|\r/", $field['options'] );
																foreach ($optionsArr as $key => $value) {
																	// Initialize variables
																	$selected = '';
						
																	// Check if '##selected' is present in the value
																	if ( strpos( $value, '##selected' ) !== false ) {
																		$selected = ' selected';
																		$value = str_replace( '##selected', '', $value );
																	}
						
																	$optionValue = $value;
																	$optionLabel = $value;
						
																	// Check if '||' separator is present in the value
																	if ( strpos( $value, '||' ) !== false )
																	{
																		list( $optionValue, $optionLabel ) = explode( '||', $value );
																	}
																	elseif ( GuestSupportApp::selectPlaceholder( $value ) )
																	{
																		$optionValue = '';
																	}
						
																	// Trim any excess whitespace
																	$optionValue = $optionValue ? trim( $optionValue ) : '';
																	$optionLabel = $optionLabel ? trim( $optionLabel ) : '';
																	// Escape and output the option
																	echo '<option value="' . esc_attr( $optionValue ) . '"' . esc_attr( $selected ) . '>' . esc_html( $optionLabel ) . '</option>';
																}
															}
															echo '</select>';
														}
														elseif ( $field['inputtype'] == 'radio' )
														{
															echo '<ul id="guest-support-field-' . esc_attr( $field['name'] ) . '" class="guest-support-field-checkbox">';
															echo '<li class="guest-support-field-checkbox-helper"><input name="' . esc_attr( $field['name'] ) . '" type="hidden" value=""></li>';
															if ( isset( $field['options'] ) && !empty( $field['options'] ) )
															{
																$optionsArr = preg_split( "/\r\n|\n|\r/", $field['options'] );
																foreach ($optionsArr as $key => $value) {
																	// Initialize variables
																	$checked = '';

																	// Check if '##checked' is present in the value
																	if ( strpos( $value, '##checked' ) !== false ) {
																		$checked = ' checked';
																		$value = str_replace( '##checked', '', $value );
																	}

																	$optionValue = $value;
																	$optionLabel = $value;

																	// Check if '||' separator is present in the value
																	if ( strpos( $value, '||' ) !== false ) {
																		list( $optionValue, $optionLabel ) = explode( '||', $value );
																	}

																	// Trim any excess whitespace
																	$optionValue = trim( $optionValue );
																	$optionLabel = trim( $optionLabel );

																	// Escape and output the option
																	echo '<li><input name="' . esc_attr( $field['name'] ) . '" type="radio" id="' . esc_attr( $field['name'] ) . '_' . $key . '" value="' . esc_attr( $optionValue ) . '"' . esc_attr( $checked ) . '><label for="' . esc_attr( $field['name'] ) . '_' . $key . '"> ' . esc_html( $optionLabel ) . '</label></li>';
																}
															}
															echo '</ul>';
														}
														elseif ( $field['inputtype'] == 'checkbox' )
														{
															echo '<ul id="guest-support-field-' . esc_attr( $field['name'] ) . '" class="guest-support-field-checkbox">';
															echo '<li class="guest-support-field-checkbox-helper"><input name="' . esc_attr( $field['name'] ) . '[]" type="hidden" value=""></li>';
															if ( isset( $field['options'] ) && !empty( $field['options'] ) )
															{
																$optionsArr = preg_split( "/\r\n|\n|\r/", $field['options'] );
																foreach ($optionsArr as $key => $value) {
																	// Initialize variables
																	$checked = '';
							
																	// Check if '##checked' is present in the value
																	if ( strpos( $value, '##checked' ) !== false ) {
																		$checked = ' checked';
																		$value = str_replace( '##checked', '', $value );
																	}

																	$optionValue = $value;
																	$optionLabel = $value;

																	// Check if '||' separator is present in the value
																	if ( strpos( $value, '||' ) !== false ) {
																		list( $optionValue, $optionLabel ) = explode( '||', $value );
																	}

																	// Trim any excess whitespace
																	$optionValue = trim( $optionValue );
																	$optionLabel = trim( $optionLabel );

																	echo '<li><input name="' . esc_attr( $field['name'] ) . '[]" type="checkbox" id="' . esc_attr( $field['name'] ) . '_' . $key . '" value="' . esc_attr( $optionValue ) . '"' . esc_attr( $checked ) . '><label for="' . esc_attr( $field['name'] ) . '_' . $key . '"> ' . esc_html( $optionLabel ) . '</label></li>';
																}
															}
															echo '</ul>';
														}
														elseif ( $field['inputtype'] == 'date' )
														{
															echo '<input type="date" name="' . esc_attr( $field['name'] ) . '" id="guest-support-field-' . esc_attr( $field['name'] ) . '" class="' . esc_attr( $form->input_class ) . '"' . ( $field['required'] == 1 ? ' required' : '' ) . '>';
														}
														elseif ( $field['inputtype'] == 'datetime' )
														{
															echo '<input type="datetime-local" name="' . esc_attr( $field['name'] ) . '" id="guest-support-field-' . esc_attr( $field['name'] ) . '" class="' . esc_attr( $form->input_class ) . '"' . ( $field['required'] == 1 ? ' required' : '' ) . '>';
														}
														elseif ( $field['inputtype'] == 'hidden' )
														{
															echo '<input type="hidden" name="' . esc_attr( $field['name'] ) . '" id="guest-support-field-' . esc_attr( $field['name'] ) . '" value="' . esc_attr( $field['hidden_value'] ) . '">';
														}
														elseif ( $field['inputtype'] == 'content' )
														{
															echo '<div class="guest-support-field-content" id="guest-support-field-' . esc_attr( $field['name'] ) . '">' . wp_kses( nl2br( stripslashes( $field['customtext'] ) ), GuestSupportApp::allowedKsesTags() ) . '</div>';
														}
														if ( isset( $field['description'] ) && $field['description'] )
														{
															echo '<div class="guest-support-field-desc">' . wp_kses( $field['description'], GuestSupportApp::allowedKsesTags() ) . '</div>';
														}
														echo '</div>';
														echo '</div>';
													}
												}
											}
										?>

										<?php if ( $form->fileupload ) : ?>
											<div class="guest-support-block guest-support-size-100">
												<div class="guest-support-field">
													<label for="" class="guest-support-field-fileupload-label"><?php echo esc_html( $form->fileupload_label ) . ' <span>(' . esc_html( $form->fileupload_help ) . ')</span>'; ?></label>
													<ul id="guest_support_fileupload_block" class="guest-support-fileupload-block">
														<li>
															<div class="guest-support-field-file">
																<input type="file" name="attachments[]" id="attachment_1" class="guest-support-field-fileupload" value="" size="25">
																<label class="guest-support-label-fileupload guest-support-grid guest-support-vcenter" for="attachment_1"><svg class="guest-support-fileupload-icon" width="14px" height="14px"><use href="#ticket_file_upload"></use></svg><span class="guest-support-block guest-support-block-fixed"><?php esc_html_e( 'Choose a file', 'guest-support' ) ; ?></span></label>
																<span class="guest-support-fileupload-remove"><svg class="guest-support-fileremove-icon" width="14px" height="14px"><use href="#ticket_file_remove"></use></svg><span class="guest-support-block guest-support-block-fixed"><?php esc_html_e( 'Remove', 'guest-support' ) ; ?></span></span>
															</div>
														</li>
														<?php if ( (int) $form->upload_filelimit > 1 ) : ?>
															<li class="guest-support-field-block-addnew">
																<div class="guest-support-field-file">
																	<div class="guest-support-field-file-addnew"><svg class="guest-support-fileaddblock-icon" width="14px" height="14px"><use href="#ticket_file_plus"></use></svg></div>
																</div>
															</li>
														<?php endif; ?>
													</ul>
												</div>
											</div>
										<?php endif; ?>

										<div class="guest-support-block guest-support-size-100">
											<div class="guest-support-field">
												<label id="closeticket-lbl" class="guest-support-label-with-input guest-support-grid guest-support-vcenter" for="closeticket">
													<input type="checkbox" name="closeticket" id="closeticket" value="1">
													&nbsp;&nbsp;<span><?php esc_html_e( "Close this ticket", "guest-support" ); ?>.</span>
												</label>
											</div>
										</div>
									</div>
									<div class="guest-support-form-submit">
										<?php wp_nonce_field( '_guest_support_submit_reply_form_957862050274', '_guest_support_submit_reply_form' ); ?>
										<input type="hidden" name="guest_support_handler" value="guest_support_submit_reply">
										<input type="hidden" name="guest_support_ticket_id" value="<?php echo esc_attr( $ticket_id ); ?>">
										<input type="hidden" name="guest_support_ticket_auth" value="<?php echo esc_attr( $ticket_token ); ?>">
										<input type="hidden" name="guest_support_handler_id" value="<?php echo esc_attr( $form->id ); ?>">
										<button type="submit" id="guest_support_submit_reply" class="<?php echo esc_attr( $form->submit_class ); ?>"><?php esc_html_e( "Submit", "guest-support" ); ?></button>
									</div>
								</form>
							</div>
						<?php else : ?>
							<div class="guest-support-alert guest-support-alert-warning"><p><?php esc_html_e( "You can't reply to this ticket as Agent, because this ticket wasn't submitted to your assigned department. If you're an Admin, login first.", "guest-support" ); ?></p></div>
						<?php endif; ?>
                    <?php else : ?>
                        <div class="guest-support-ticket-closed-wrapper">
                            <h3><?php esc_html_e( "This ticket is closed.", "guest-support" ); ?></h3>
                            <p>
                                <?php
                                    if ( $config->reopen_closed_ticket == 'agent' && $isagent !== false )
                                    {
                                        echo wp_kses( $ticket_reopen_text, GuestSupportApp::allowedKsesTags() );
                                    }
                                    elseif ( $config->reopen_closed_ticket == 'user' && $isagent === false )
                                    {
                                        echo wp_kses( $ticket_reopen_text, GuestSupportApp::allowedKsesTags() );
                                    }
                                    elseif ( $config->reopen_closed_ticket == 'both' )
                                    {
                                        echo wp_kses( $ticket_reopen_text, GuestSupportApp::allowedKsesTags() );
                                    }
                                    else
                                    {
                                        echo esc_html__( "Please create another support ticket if necessary.", "guest-support" );
                                    }
                                ?>
                            </p>
                        </div>
                    <?php endif; ?>
                </div>
            </div>
        </div>
        <div class="guest-support-block guest-support-size-5"></div>
        <div class="guest-support-block guest-support-size-30 guest-support-ticket-info">
            <div class="guest-support-ticket-content">
				<?php if ( $params_top_text ) : ?>
					<div class="guest-support-ticket-top-text"><?php echo wp_kses_post( $params_top_text ); ?></div>
				<?php endif; ?>
				<?php if ( $params_display_ticket_id !== 'none' ) : ?>
					<div class="guest-support-ticket-info-status">
						<h4><?php esc_html_e( "Ticket ID:", "guest-support" ); ?></h4>
						<p><?php echo $params_display_ticket_id === 'default' ? sanitize_text_field( $ticketSubject->ticket_id ) : sanitize_text_field( $ticketSubject->short_ticket_id ); ?></p>
					</div>
				<?php endif; ?>
				<?php if ( (int) $params_display_ticket_status === 1 ) : ?>
					<div class="guest-support-ticket-info-status">
						<h4><?php esc_html_e( "Ticket status:", "guest-support" ); ?></h4>
						<p>
							<?php 
								echo esc_html( ucwords( $ticketSubject->status ) ); 
								if ( $ticketSubject->status != 'closed' )
								{
									echo ' / <a href="' . esc_url( $current_url . '&guest_support_handler=closeticket' ) . '">' . esc_html__( 'Close ticket', 'guest-support' ) . '</a>';
								}
								else
								{
									if ( $config->reopen_closed_ticket == 'agent' && $isagent !== false ) {
										echo ' / ' . wp_kses( $ticket_reopen_shorttext, GuestSupportApp::allowedKsesTags() );
									}
									elseif ( $config->reopen_closed_ticket == 'user' && $isagent === false ) {
										echo ' / ' . wp_kses( $ticket_reopen_shorttext, GuestSupportApp::allowedKsesTags() );
									}
									elseif ( $config->reopen_closed_ticket == 'both' ) {
										echo ' / ' . wp_kses( $ticket_reopen_shorttext, GuestSupportApp::allowedKsesTags() );
									}
								}
							?>
						</p>
						<?php
							if ( $isagent && $config->can_delete_tickets == 'yes' )
							{
								echo '<p class="guest-support-ticket-info-delete"><a id="guest-support-delete" href="' . esc_url( $current_url . '&guest_support_handler=deleteticket' ) . '" target="">' . esc_html__( "Delete Ticket", "guest-support" ) . '</a></p>';
							}
						?>
					</div>
				<?php endif; ?>
				<?php if ( (int) $params_display_department === 1 ) : ?>
					<div class="guest-support-ticket-info-department">
						<h4><?php esc_html_e( "Department:", "guest-support" ); ?></h4>
						<p><?php echo esc_html( $ticketSubject->department_name ); ?></p>
					</div>
				<?php endif; ?>
				<?php if ( (int) $params_display_ticket_creation_date === 1 ) : ?>
					<div class="guest-support-ticket-info-created">
						<h4><?php esc_html_e( "Ticket created date:", "guest-support" ); ?></h4>
						<p><?php echo esc_html( wp_date( $params_ticket_creation_date_format, $ticketSubject->created_date ) ); ?></p>
					</div>
				<?php endif; ?>
				<?php if ( (int) $params_display_last_updated_date === 1 ) : ?>
					<div class="guest-support-ticket-info-last-updated">
						<h4><?php esc_html_e( "Last updated date:", "guest-support" ); ?></h4>
						<p><?php echo esc_html( wp_date( $params_last_updated_date_format, $ticketSubject->last_update_date ) ); ?></p>
					</div>
				<?php endif; ?>

                <?php
                    if ( (int) $params_display_custom_fields === 1 && !empty( $custom_fields ) )
                    {
						$custom_fields_data = '';
						foreach ($custom_fields as $name => $value) {
							$custom_info = '';
							$inputname = 'field_' . $name;
							if ( isset( $formFields[$inputname]['showonticketview'] ) && $formFields[$inputname]['showonticketview'] != 'hide' )
							{
								if ( ( is_array( $value ) && !empty( $value ) ) || !empty( $value ) )
								{
									if ( isset( $formFields[$inputname]['label'] ) )
									{
										$custom_info .= '<h4 class="guest-support-ticket-info-label-' . esc_attr( $name ) . '">' . esc_html( $formFields[$inputname]['label'] ) . ':</h4>';
									}

									if ( !is_user_logged_in() && isset( $formFields[$inputname]['login_required'] ) && (int) $formFields[$inputname]['login_required'] === 1 )
									{
										$custom_info .= '<div class="guest-support-custom-field-value-login-required guest-support-alert guest-support-alert-warning"><span><svg width="16px" height="16px"><use href="#ticket_lock"></use></svg></span><div>' . esc_html__( 'Login to view this message.', 'guest-support' ) . '</div></div>';
									}
									else
									{
										if ( is_array( $value ) )
										{
											$fieldvalue = implode( ', ', $value );
										}
										else
										{
											$fieldvalue = str_replace( '__', ' ', $value);
										}
										$custom_info .= '<div class="guest-support-ticket-info-value-' . esc_attr( $name ) . '">' . stripslashes( esc_html( $fieldvalue ) ) . '</div>';
									}
								}
								if ( ( $formFields[$inputname]['showonticketview'] == 'users' || $formFields[$inputname]['showonticketview'] == 'both' ) && !$isagent )
								{
									$custom_fields_data .= $custom_info;
								}
								elseif ( ( $formFields[$inputname]['showonticketview'] == 'agents' || $formFields[$inputname]['showonticketview'] == 'both' ) && $isagent )
								{
									$custom_fields_data .= $custom_info;
								}
							}
						}
						if ( $custom_fields_data )
						{
							echo '<div class="guest-support-ticket-info-custom-fields">';
							echo GuestSupportApp::wp_kses_extended( $custom_fields_data );
							echo '</div>';
						}
                    }
                ?>

				<?php if ( 
						$params_display_other_tickets === 'both' ||
						( $params_display_other_tickets === 'agent' && $isagent ) ||
						( $params_display_other_tickets === 'user' && !$isagent )
					) : ?>
					<div class="guest-support-ticket-info-others">
						<?php if ( $otherTickets !== false ) : ?>
							<h4>
								<?php
									if ( $isagent )
									{
										echo esc_html__( "Recent tickets by this user:", "guest-support" );
									}
									else
									{
										echo esc_html__( "My recent tickets:", "guest-support" );
									}
								?>
							</h4>
							<ol class="guest-support-ticket-othersbyuser">
								<?php
									foreach ( $otherTickets as $ticket ) {
										echo '<li><a href="' . esc_url( GuestSupportApp::getTicketPageUrl() . $ticket->ticket_id . '/?auth=' . $ticket->ticket_token . ( $isagent ? '&agent=' . $agent_id_enc : '' ) ) . '">' . esc_html( stripslashes( $ticket->subject ) ) . '</a></li>';
									}
								?>
							</ol>
						<?php endif; ?>
					</div>
				<?php endif; ?>
				<?php if ( $params_bottom_text ) : ?>
					<div class="guest-support-ticket-bottom-text"><?php echo wp_kses_post( $params_bottom_text ); ?></div>
				<?php endif; ?>
            </div>
        </div>
    </div>
    <?php if ( $form->fileupload ) : ?>
        <?php
            $fileLimit = $form->upload_filelimit;
            $totalSize = $form->upload_filesize;
            $fileTypes = $form->allowed_filetypes;
            $text_onefile = esc_html__( "Error: Please select one file at a time.", "guest-support" );
            $text_sizelimitexceded = esc_html__( "Error: You have exceded total maximum allowed file size.", "guest-support" );
            $text_uploadfile = esc_html__( "Choose a file", "guest-support" );
            $text_remove = esc_html__( "Remove", "guest-support" );
            $text_filelimitexceded = esc_html__( "Error: You have exceded maximum allowed files.", "guest-support" );
            $text_invalidextension = esc_html__( "Error: Invalid file. Supported file types are:", "guest-support" );
        ?>
    <?php endif; ?>
    <script>
        jQuery(document).ready(function($) {
            $('html, body').animate({
                <?php if ( GuestSupportApp::isErrorNotice() === true ) : ?>
                    scrollTop: $("div.guest-support-alert").offset().top -120
                <?php else: ?>
                    scrollTop: $("div#guest-support-ticket-message-last").offset().top -120
                <?php endif; ?>
            }, 500);
            <?php if ( $form->fileupload ) : ?>
                $.guest_support_CheckFileUpload(<?php echo esc_html( $fileLimit ); ?>, <?php echo esc_html( $totalSize ); ?>, "<?php echo esc_html( $fileTypes ); ?>", "<?php echo esc_html( $text_onefile ); ?>", "<?php echo esc_html( $text_sizelimitexceded ); ?>", "<?php echo esc_html( $text_filelimitexceded ); ?>", "<?php echo esc_html( $text_uploadfile ); ?>", "<?php echo esc_html( $text_invalidextension ); ?>");
                $.guest_support_AddFileUploadBlock(<?php echo esc_html( $fileLimit ); ?>, "<?php echo esc_html( $text_uploadfile ); ?>", "<?php echo esc_html( $text_remove ); ?>", "<?php echo esc_html( $text_filelimitexceded ); ?>");
            <?php endif; ?>
        });
    </script>
    <div id="guest_support_edit_reply_modal" class="guest-support-modal">
        <div class="guest-support-modal-wrapper">
            <div class="guest-support-modal-container">
                <div class="guest-support-modal-container-wrapper">
                    <div class="guest-support-modal-content">
                        <div id="guest_support_modal_main_content">
                            <div class="guest-support-editreply-field">
                                <?php
                                    $content = "";
                                    $custom_editor_id = 'guest-support-edit-message';
                                    $custom_editor_name = 'edit-message';
                                    $args = array(
                                            'media_buttons' => false,
                                            'textarea_name' => $custom_editor_name,
                                            'textarea_rows' => get_option('default_post_edit_rows', 10),
                                            'quicktags' => false,
                                            'tinymce'       => array(
                                                'toolbar1'      => 'bold,italic,underline,separator,alignleft,aligncenter,alignright,separator,link,unlink,bullist,numlist,undo,redo',
                                                'toolbar2'      => '',
                                                'toolbar3'      => '',
                                            )
                                        );
                                    wp_editor( $content, $custom_editor_id, $args );
                                ?>
                            </div>
                            <div class="guest-support-editreply-notice"></div>
                            <div class="guest-support-editreply-notice-success" style="display:none" ><?php esc_html_e( "Message updated successfully.", "guest-support" ); ?></div>
                            <div class="guest-support-editreply-submit">
                                <button id="guest_support_submit_editreply" class="<?php echo esc_attr( $form->submit_class ); ?>"><?php esc_html_e( "Confirm Edit", "guest-support" ); ?></button>
                            </div>
                        </div>
                    </div>
                    <div class="guest-support-modal-footer">
                        <a href="javascript:;" id="guest_support_modal_close" class="guest-support-button button-cancel"><?php esc_html_e( 'Cancel', 'guest-support' ); ?></a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
